// This file is generated by kconfig_compiler_kf5 from virtualdesktopssettings.kcfg.
// All changes you do to this file will be lost.
#ifndef VIRTUALDESKTOPSSETTINGS_H
#define VIRTUALDESKTOPSSETTINGS_H

#include <qglobal.h>
#include <kconfigskeleton.h>
#include <QCoreApplication>
#include <QDebug>

class VirtualDesktopsSettings : public KConfigSkeleton
{
  Q_OBJECT
  public:

    VirtualDesktopsSettings( QObject *parent = nullptr );
    ~VirtualDesktopsSettings();

    /**
      Set Whether or not, we circle through the virtual desktop when moving from one to the next
    */
    void setRollOverDesktops( bool v )
    {
      if (v != mRollOverDesktops && !isImmutable( QStringLiteral( "rollOverDesktops" ) )) {
        mRollOverDesktops = v;
        Q_EMIT rollOverDesktopsChanged();
      }
    }

    Q_PROPERTY(bool rollOverDesktops READ rollOverDesktops WRITE setRollOverDesktops NOTIFY rollOverDesktopsChanged)
    /**
      Get Whether or not, we circle through the virtual desktop when moving from one to the next
    */
    bool rollOverDesktops() const
    {
      return mRollOverDesktops;
    }

    /**
      Get Whether or not, we circle through the virtual desktop when moving from one to the next default value
    */
    bool defaultRollOverDesktopsValue() const
    {
        return defaultRollOverDesktopsValue_helper();
    }

    /**
      Set Display in an OSD the virtual desktop name when switching between virtual desktops
    */
    void setDesktopChangeOsdEnabled( bool v )
    {
      if (v != mDesktopChangeOsdEnabled && !isImmutable( QStringLiteral( "desktopChangeOsdEnabled" ) )) {
        mDesktopChangeOsdEnabled = v;
        Q_EMIT desktopChangeOsdEnabledChanged();
      }
    }

    Q_PROPERTY(bool desktopChangeOsdEnabled READ desktopChangeOsdEnabled WRITE setDesktopChangeOsdEnabled NOTIFY desktopChangeOsdEnabledChanged)
    /**
      Get Display in an OSD the virtual desktop name when switching between virtual desktops
    */
    bool desktopChangeOsdEnabled() const
    {
      return mDesktopChangeOsdEnabled;
    }

    /**
      Get Display in an OSD the virtual desktop name when switching between virtual desktops default value
    */
    bool defaultDesktopChangeOsdEnabledValue() const
    {
        return defaultDesktopChangeOsdEnabledValue_helper();
    }

    /**
      Set Duraton of the OSD
    */
    void setPopupHideDelay( int v )
    {
      if (v != mPopupHideDelay && !isImmutable( QStringLiteral( "popupHideDelay" ) )) {
        mPopupHideDelay = v;
        Q_EMIT popupHideDelayChanged();
      }
    }

    Q_PROPERTY(int popupHideDelay READ popupHideDelay WRITE setPopupHideDelay NOTIFY popupHideDelayChanged)
    /**
      Get Duraton of the OSD
    */
    int popupHideDelay() const
    {
      return mPopupHideDelay;
    }

    /**
      Get Duraton of the OSD default value
    */
    int defaultPopupHideDelayValue() const
    {
        return defaultPopupHideDelayValue_helper();
    }

    /**
      Set Whether or not to display desktop layout in the OSD
    */
    void setTextOnly( bool v )
    {
      if (v != mTextOnly && !isImmutable( QStringLiteral( "textOnly" ) )) {
        mTextOnly = v;
        Q_EMIT textOnlyChanged();
      }
    }

    Q_PROPERTY(bool textOnly READ textOnly WRITE setTextOnly NOTIFY textOnlyChanged)
    /**
      Get Whether or not to display desktop layout in the OSD
    */
    bool textOnly() const
    {
      return mTextOnly;
    }

    /**
      Get Whether or not to display desktop layout in the OSD default value
    */
    bool defaultTextOnlyValue() const
    {
        return defaultTextOnlyValue_helper();
    }


    enum {
      signalRollOverDesktopsChanged = 0x1,
      signalDesktopChangeOsdEnabledChanged = 0x2,
      signalPopupHideDelayChanged = 0x4,
      signalTextOnlyChanged = 0x8
    };

  Q_SIGNALS:
    void rollOverDesktopsChanged();

    void desktopChangeOsdEnabledChanged();

    void popupHideDelayChanged();

    void textOnlyChanged();

  private:
    void itemChanged(quint64 flags);

  protected:

    // Windows
    bool mRollOverDesktops;
    bool defaultRollOverDesktopsValue_helper() const;

    // Plugins
    bool mDesktopChangeOsdEnabled;
    bool defaultDesktopChangeOsdEnabledValue_helper() const;

    // Script-desktopchangeosd
    int mPopupHideDelay;
    int defaultPopupHideDelayValue_helper() const;
    bool mTextOnly;
    bool defaultTextOnlyValue_helper() const;

  private:
};

#endif

